﻿using System;
using System.Globalization;
using System.IO;
using Silanis.ESL.SDK;
using Silanis.ESL.SDK.Builder;
using System.Collections.Generic;
 
namespace SDK.Examples
{
    public class DocumentWorkflow
    {
        public static string API_KEY = <YOUR API KEY HERE>;
        public static string API_URL = <ENVIRONMENT URL HERE>;
 
        public static void Main (string[] args) {

            EslClient eslClient = new EslClient( API_KEY, API_URL );
          
            DocumentPackage superDuperPackage = PackageBuilder.NewPackageNamed("Policy")
                    .DescribedAs("This is a package with a document workflow created using the e-SignLive SDK")
                    .WithSigner(SignerBuilder.NewSignerWithEmail("john@email.com")
                            .WithFirstName("John")
                            .WithLastName("Smith"))
                    .WithDocument(DocumentBuilder.NewDocumentNamed("Second Document")
                            .FromFile("src/main/resources/document.pdf")
                            .AtIndex(2)
                            .WithSignature(SignatureBuilder.SignatureFor("john@email.com")
                                    .OnPage(0)
                                    .AtPosition(100, 100)))
                    .WithDocument(DocumentBuilder.NewDocumentNamed("First Document")
                            .FromFile("src/main/resources/document.pdf")
                            .AtIndex(1)
                            .WithSignature(SignatureBuilder.SignatureFor("john@email.com")
                                    .OnPage(0)
                                    .AtPosition(100, 100)))
                    .Build();
 
            PackageId packageId = eslClient.CreatePackage( superDuperPackage );
 
            eslClient.SendPackage( packageId );

            // Reorder the documents: swap the order of the two documents
            DocumentPackage savedPackage = eslClient.GetPackage(packageId);

            savedPackage.GetDocument("First Document").Index = 2;
            savedPackage.GetDocument("Second Document").Index = 1;
            eslClient.PackageService.OrderDocuments(savedPackage);
 
            eslClient.SendPackage( packageId );
        }
    }
}